if select(2, UnitClass('player')) ~= 'WARRIOR' then
	DisableAddOn('Smash')
	return
end

Smash = {}

SLASH_Smash1, SLASH_Smash2 = '/smash', '/sm'
BINDING_HEADER_SMASH = 'Smash'

local function InitializeVariables()
	for k, v in pairs({ -- defaults
		locked = false,
		scale_main = 1,
		scale_previous = 0.7,
		scale_cooldown = 0.7,
		scale_interrupt = 0.4,
		scale_enrage = 0.4,
		alpha = 1,
		frequency = 0.05,
		previous = true,
		always_on = false,
		cooldown = true,
		aoe = false,
		gcd = true,
		dimmer = true,
		miss_effect = true,
		glow_main = true,
		glow_cooldown = true,
		glow_interrupt = false,
		glow_blizzard = false,
		boss_only = false,
		hide_spec = 0,
		interrupt = true,
		enrage = true,
		pot = false,
		stance = true,
		shout = true,
		reckless_bloodbath = false
	}) do
		if Smash[k] == nil then
			Smash[k] = v
		end
	end
end

local events, var, abilities, ability, glows = {}, {}, {}, {}, {}
local me, abilityTimer, currentSpec, targetMode = 0, 0, 0, 0

local smashPanel = CreateFrame('Frame', 'smashPanel', UIParent)
smashPanel:SetPoint('CENTER', 0, -169)
smashPanel:SetFrameStrata('BACKGROUND')
smashPanel:SetSize(64, 64)
smashPanel:SetMovable(true)
smashPanel:Hide()
smashPanel.icon = smashPanel:CreateTexture(nil, 'BACKGROUND')
smashPanel.icon:SetAllPoints(smashPanel)
smashPanel.icon:SetTexCoord(0.05, 0.95, 0.05, 0.95)
smashPanel.border = smashPanel:CreateTexture(nil, 'BORDER')
smashPanel.border:SetAllPoints(smashPanel)
smashPanel.border:SetTexture('Interface\\AddOns\\Smash\\border.blp')
smashPanel.border:Hide()
smashPanel.gcd = CreateFrame('Cooldown', nil, smashPanel, 'CooldownFrameTemplate')
smashPanel.gcd:SetAllPoints(smashPanel)
smashPanel.dimmer = smashPanel:CreateTexture(nil, 'OVERLAY')
smashPanel.dimmer:SetAllPoints(smashPanel)
smashPanel.dimmer:SetTexture(0, 0, 0, 0.6)
smashPanel.dimmer:Hide()
smashPanel.targets = smashPanel:CreateFontString(nil, 'OVERLAY')
smashPanel.targets:SetFont('Fonts\\FRIZQT__.TTF', 12, 'OUTLINE')
smashPanel.targets:SetPoint('BOTTOMRIGHT', smashPanel, 'BOTTOMRIGHT', -1.5, 3)
smashPanel.button = CreateFrame('Button', 'smashPanelButton', smashPanel)
smashPanel.button:SetAllPoints(smashPanel)
smashPanel.button:RegisterForClicks('LeftButtonDown', 'RightButtonDown', 'MiddleButtonDown')
local smashPreviousPanel = CreateFrame('Frame', 'smashPreviousPanel', UIParent)
smashPreviousPanel:SetPoint('BOTTOMRIGHT', smashPanel, 'BOTTOMLEFT', -10, -5)
smashPreviousPanel:SetFrameStrata('BACKGROUND')
smashPreviousPanel:SetSize(64, 64)
smashPreviousPanel:Hide()
smashPreviousPanel:RegisterForDrag('LeftButton')
smashPreviousPanel:SetScript('OnDragStart', smashPreviousPanel.StartMoving)
smashPreviousPanel:SetScript('OnDragStop', smashPreviousPanel.StopMovingOrSizing)
smashPreviousPanel:SetMovable(true)
smashPreviousPanel.icon = smashPreviousPanel:CreateTexture(nil, 'BACKGROUND')
smashPreviousPanel.icon:SetAllPoints(smashPreviousPanel)
smashPreviousPanel.icon:SetTexCoord(0.05, 0.95, 0.05, 0.95)
smashPreviousPanel.border = smashPreviousPanel:CreateTexture(nil, 'BORDER')
smashPreviousPanel.border:SetAllPoints(smashPreviousPanel)
smashPreviousPanel.border:SetTexture('Interface\\AddOns\\Smash\\border.blp')
local smashCooldownPanel = CreateFrame('Frame', 'smashCooldownPanel', UIParent)
smashCooldownPanel:SetPoint('BOTTOMLEFT', smashPanel, 'BOTTOMRIGHT', 10, -5)
smashCooldownPanel:SetSize(64, 64)
smashCooldownPanel:SetFrameStrata('BACKGROUND')
smashCooldownPanel:Hide()
smashCooldownPanel:RegisterForDrag('LeftButton')
smashCooldownPanel:SetScript('OnDragStart', smashCooldownPanel.StartMoving)
smashCooldownPanel:SetScript('OnDragStop', smashCooldownPanel.StopMovingOrSizing)
smashCooldownPanel:SetMovable(true)
smashCooldownPanel.icon = smashCooldownPanel:CreateTexture(nil, 'BACKGROUND')
smashCooldownPanel.icon:SetAllPoints(smashCooldownPanel)
smashCooldownPanel.icon:SetTexCoord(0.05, 0.95, 0.05, 0.95)
smashCooldownPanel.border = smashCooldownPanel:CreateTexture(nil, 'BORDER')
smashCooldownPanel.border:SetAllPoints(smashCooldownPanel)
smashCooldownPanel.border:SetTexture('Interface\\AddOns\\Smash\\border.blp')
smashCooldownPanel.cd = CreateFrame('Cooldown', nil, smashCooldownPanel, 'CooldownFrameTemplate')
smashCooldownPanel.cd:SetAllPoints(smashCooldownPanel)
local smashInterruptPanel = CreateFrame('Frame', 'smashInterruptPanel', UIParent)
smashInterruptPanel:SetPoint('TOPLEFT', smashPanel, 'TOPRIGHT', 16, 25)
smashInterruptPanel:SetFrameStrata('BACKGROUND')
smashInterruptPanel:SetSize(64, 64)
smashInterruptPanel:Hide()
smashInterruptPanel:RegisterForDrag('LeftButton')
smashInterruptPanel:SetScript('OnDragStart', smashInterruptPanel.StartMoving)
smashInterruptPanel:SetScript('OnDragStop', smashInterruptPanel.StopMovingOrSizing)
smashInterruptPanel:SetMovable(true)
smashInterruptPanel.icon = smashInterruptPanel:CreateTexture(nil, 'BACKGROUND')
smashInterruptPanel.icon:SetAllPoints(smashInterruptPanel)
smashInterruptPanel.icon:SetTexCoord(0.05, 0.95, 0.05, 0.95)
smashInterruptPanel.border = smashInterruptPanel:CreateTexture(nil, 'BORDER')
smashInterruptPanel.border:SetAllPoints(smashInterruptPanel)
smashInterruptPanel.border:SetTexture('Interface\\AddOns\\Smash\\border.blp')
smashInterruptPanel.cast = CreateFrame('Cooldown', nil, smashInterruptPanel, 'CooldownFrameTemplate')
smashInterruptPanel.cast:SetAllPoints(smashInterruptPanel)
local smashEnragePanel = CreateFrame('Frame', 'smashEnragePanel', UIParent)
smashEnragePanel:SetPoint('TOPRIGHT', smashPanel, 'TOPLEFT', -16, 25)
smashEnragePanel:SetFrameStrata('BACKGROUND')
smashEnragePanel:SetSize(64, 64)
smashEnragePanel:Hide()
smashEnragePanel:RegisterForDrag('LeftButton')
smashEnragePanel:SetScript('OnDragStart', smashEnragePanel.StartMoving)
smashEnragePanel:SetScript('OnDragStop', smashEnragePanel.StopMovingOrSizing)
smashEnragePanel:SetMovable(true)
smashEnragePanel.icon = smashEnragePanel:CreateTexture(nil, 'BACKGROUND')
smashEnragePanel.icon:SetAllPoints(smashEnragePanel)
smashEnragePanel.icon:SetTexCoord(0.05, 0.95, 0.05, 0.95)
smashEnragePanel.border = smashEnragePanel:CreateTexture(nil, 'BORDER')
smashEnragePanel.border:SetAllPoints(smashEnragePanel)
smashEnragePanel.border:SetTexture('Interface\\AddOns\\Smash\\border.blp')
smashEnragePanel.duration = CreateFrame('Cooldown', nil, smashEnragePanel, 'CooldownFrameTemplate')
smashEnragePanel.duration:SetAllPoints(smashEnragePanel)

local Ability = {}
Ability.__index = Ability

function Ability.add(spellId, buff, player, spellId2)
	local name, _, icon = GetSpellInfo(spellId)
	local ability = {
		spellId = spellId,
		spellId2 = spellId2 or 0,
		name = name,
		icon = icon,
		known = IsPlayerSpell(spellId),
		auraTarget = buff and 'player' or 'target',
		auraFilter = (buff and 'HELPFUL' or 'HARMFUL') .. (player and '|PLAYER' or '')
	}
	setmetatable(ability, Ability)
	abilities[#abilities + 1] = ability
	return ability
end

function Ability:ready(seconds)
	return self:cooldown() <= max(seconds or 0, var.gcd)
end

function Ability:remains()
	local _, id, expires
	for i = 1, 40 do
		_, _, _, _, _, _, expires, _, _, _, id = UnitAura(self.auraTarget, i, self.auraFilter)
		if id == self.spellId or id == self.spellId2 then
			return expires - var.time
		end
	end
	return 0
end

function Ability:up()
	local _, id
	for i = 1, 40 do
		_, _, _, _, _, _, _, _, _, _, id = UnitAura(self.auraTarget, i, self.auraFilter)
		if id == self.spellId or id == self.spellId2 then
			return true
		end
	end
end

function Ability:down()
	return not self:up()
end

function Ability:cooldown()
	local start, duration = GetSpellCooldown(self.spellId)
	return duration - (var.time - start)
end

function Ability:stack()
	local _, id, count
	for i = 1, 40 do
		_, _, _, count, _, _, _, _, _, _, id = UnitAura(self.auraTarget, i, self.auraFilter)
		if id == self.spellId or id == self.spellId2 then
			return count
		end
	end
	return 0
end

function Ability:charges()
	return (GetSpellCharges(self.spellId))
end

function Ability:usable()
	return IsUsableSpell(self.spellId)
end

-- Warrior Abilities
local AngerManagement = Ability.add(152278, true, true)
local Avatar = Ability.add(107574, true, true)
local BattleStance = Ability.add(2457, true, true)
local BattleShout = Ability.add(6673, true, true)
local BerserkerRage = Ability.add(18499, true, true)
local Bladestorm = Ability.add(46924, true, true)
local Bloodbath = Ability.add(12292, true, true)
local Bloodthirst = Ability.add(23881, false, true)
local Bloodsurge = Ability.add(46916, true, true)
local Charge = Ability.add(100, true, true)
local ColossusSmash = Ability.add(167105, false, true)
local CommandingShout = Ability.add(469, true)
local DeepWounds = Ability.add(115767, false, true)
local DefensiveStance = Ability.add(71, true, true)
local Devastate = Ability.add(20243, false, true)
local DragonRoar = Ability.add(118000, false, true)
local Enrage = Ability.add(12880, true, true)
local Execute = Ability.add(5308, false, true)
local ExecuteArms = Ability.add(163201, false, true)
local GladiatorStance = Ability.add(156291, true, true)
local HeroicLeap = Ability.add(6544, false, true)
local HeroicStrike = Ability.add(78, false, true)
local HeroicThrow = Ability.add(57755, false, true)
local ImpendingVictory = Ability.add(103840, false, true)
local MeatCleaver = Ability.add(85739, true, true)
local MortalStrike = Ability.add(12294, true, true)
local Pummel = Ability.add(6552, false, true)
local RagingBlow = Ability.add(85288, false, true)
local RagingBlowBuff = Ability.add(131116, true, true)
local Ravager = Ability.add(152277, false, true)
local Recklessness = Ability.add(1719, true, true)
local Rend = Ability.add(772, false, true)
local Revenge = Ability.add(6572, false, true)
local ShatteringThrow = Ability.add(64382, false, true)
local ShieldCharge = Ability.add(156321, false, true)
local Shockwave = Ability.add(46968, true, true)
local Siegebreaker = Ability.add(176289, false, true)
local ShieldCharge = Ability.add(156321, true, true, 169667)
local ShieldSlam = Ability.add(23922, false, true)
local Slam = Ability.add(1464, true, true)
local StormBolt = Ability.add(107570, false, true)
local SuddenDeath = Ability.add(52437, true, true)
local SweepingStrikes = Ability.add(12328, true, true)
local ThunderClap = Ability.add(6343, false, true)
local Ultimatum = Ability.add(122510, true, true)
local UnyieldingStrikes = Ability.add(169686, true, true)
local UnquenchableThirst = Ability.add(169683, true, true)
local VictoryRush = Ability.add(34428, false, true)
local Whirlwind = Ability.add(1680, false, true)
local WildStrike = Ability.add(100130, false, true)
-- Glyphs
local GlyphOfResonatingPower = Ability.add(58356, true, true)
-- Tier Bonuses

-- Potions
local DraenicStrength = Ability.add(156428, true, true)
-- Trinkets

local targetModes = {
	[0] = { {1, ''} },
	[1] = {
		{1, ''},
		{2, '2'},
		{5, '5+'}
	},
	[2] = {
		{1, ''},
		{2, '2'},
		{3, '3'},
		{4, '4+'}
	},
	[3] = {
		{1, ''},
		{2, '2'},
		{4, '5'},
		{7, '7+'}
	}
}

local Target = {
	boss = false,
	guid = 0,
	healthArray = {},
	hostile = false
}

local function UpdateVars()
	local _, start, duration, remains, hp
	ability.last_main = ability.main
	ability.last_cd = ability.cd
	var.time = GetTime()
	start, duration = GetSpellCooldown(5308)
	var.gcd = start > 0 and duration - (var.time - start) or 0
	var.rage = UnitPower('player')
	var.rage_max = UnitPowerMax('player')
	Target.healthArray[#Target.healthArray + 1] = UnitHealth('target')
	table.remove(Target.healthArray, 1)
	Target.healthPercentage = Target.guid == 0 and 100 or UnitHealth('target') / UnitHealthMax('target') * 100
	hp = Target.healthArray[1] - Target.healthArray[#Target.healthArray]
	Target.timeToDie = hp > 0 and Target.healthArray[#Target.healthArray] / (hp / 3) or 600
end

local InCombat = InCombatLockdown

local function Rage()
	return var.rage
end

local function RageMax()
	return var.rage_max
end

local function HealthPercentage()
	return UnitHealth('player') / UnitHealthMax('player') * 100
end

local function Enemies()
	return targetModes[currentSpec][targetMode][1]
end

local function InBattleStance()
	return GetShapeshiftForm() == 1
end

function DraenicStrength:cooldown()
	local startTime, duration = GetItemCooldown(109219)
	return duration - (var.time - startTime)
end

local function APBuffActive()
	local _, id, duration, expires
	for i = 1, 40 do
		_, _, _, _, _, duration, expires, _, _, _, id = UnitBuff('player', i)
		if id == 6673 or id == 19506 or id == 57330 then
			return duration == 0 or expires - var.time > 10
		end
	end
end

local function StaminaBuffActive()
	local _, id, duration, expires
	for i = 1, 40 do
		_, _, _, _, _, duration, expires, _, _, _, id = UnitBuff('player', i)
		if id == 469 or id == 21562 or id == 166928 or id == 50256 or id == 160014 or id == 160003 or id == 90364 then
			return duration == 0 or expires - var.time > 10
		end
	end
end

local function UseCooldown(overwrite)
	return Smash.cooldown and (not Smash.boss_only or Target.boss) and (not ability.cd or overwrite)
end

local function DetermineAbilityArms()
	if UseCooldown() then
		if Smash.pot and DraenicStrength:ready() and ((Target.healthPercentage < 20 and Recklessness:up()) or Target.timeToDie < 25) then
			ability.cd = DraenicStrength
		elseif Ravager.known and Ravager:ready() and Rend:up() and ((Enemies() == 1 and ColossusSmash:ready(4)) or (Enemies() > 1 and (Bloodbath:up() or not Bloodbath.known))) then
			ability.cd = Ravager
		elseif Recklessness:ready() and Rend:up() and (((Target.timeToDie > 190 or Target.healthPercentage < 20) and (Bloodbath:up() or (Smash.reckless_bloodbath and Bloodbath:ready()) or (not Bloodbath.known and (ColossusSmash:ready(2) or ColossusSmash:remains() > 6)))) or Target.timeToDie < 10) then
			ability.cd = Recklessness
		elseif Bloodbath.known and Bloodbath:ready() and Rend:up() and (Recklessness:up() or ColossusSmash:ready(5) or Target.timeToDie < 20) then
			ability.cd = Bloodbath
		elseif Avatar.known and Avatar:ready() and (Recklessness:up() or Target.timeToDie < 25) then
			ability.cd = Avatar
		end
	end
	if Smash.stance and not InBattleStance() then
		return BattleStance
	elseif Smash.shout then
		if not APBuffActive() then
			return BattleShout
		elseif not (InCombat() or StaminaBuffActive() or BattleShout:up()) then
			return CommandingShout
		end
	end
	if Enemies() == 1 then
		if Rend:down() and Target.timeToDie > 4 then
			return Rend
		elseif ColossusSmash:ready() then
			return ColossusSmash
		elseif Rage() >= 20 and MortalStrike:ready() and Target.healthPercentage > 20 and not ColossusSmash:ready(1) then
			return MortalStrike
		elseif StormBolt.known and StormBolt:ready() and Rage() < 90 and (ColossusSmash:up() or not ColossusSmash:ready(4)) then
			return StormBolt
		elseif Siegebreaker.known and Siegebreaker:ready() then
			return Siegebreaker
		end
		if UseCooldown() and DragonRoar.known and DragonRoar:ready() and ColossusSmash:down() then
			ability.cd = DragonRoar
		end
		if ColossusSmash:down() and Target.timeToDie > Rend:remains() + 4 and Rend:remains() < 5.4 then
			return Rend
		elseif SuddenDeath:up() or (Target.healthPercentage < 20 and ((Rage() >= 60 and not ColossusSmash:ready(1.5)) or (Rage() >= 10 and (ColossusSmash:up() or Target.timeToDie < 5)))) then
			return ExecuteArms
		end
		if UseCooldown() and Bladestorm.known and Bladestorm:ready() and Rend:remains() > 6 and not ColossusSmash:ready(6) then
			ability.cd = Bladestorm
		end
		if Target.healthPercentage > 20 and not (MortalStrike:ready(1) or ColossusSmash:ready(1)) then
			if Rage() >= (ColossusSmash:up() and 10 or 30) and ImpendingVictory.known and ImpendingVictory:ready() then
				return ImpendingVictory
			elseif Rage() >= (ColossusSmash:up() and 10 or 30) and GlyphOfResonatingPower.known and ThunderClap:ready() then
				return ThunderClap
			elseif Rage() >= (ColossusSmash:up() and 20 or 40) then
				return Whirlwind
			end
		end
		if UseCooldown() and Shockwave.known and Shockwave:ready() then
			ability.cd = Shockwave
		end
	else
		if Rage() >= 10 and SweepingStrikes:down() then
			return SweepingStrikes
		elseif Rend:remains() < 3 and Target.timeToDie > 4 then
			return Rend
		elseif ColossusSmash:ready(0.5) then
			return ColossusSmash
		end
		if Enemies() < 5 and Rage() >= 20 and MortalStrike:ready() and Target.healthPercentage > 20 and not ColossusSmash:ready(1.5) then
			return MortalStrike
		elseif (SuddenDeath:up() or (Target.healthPercentage < 20 and Rage() >= 10)) and (((Rage() >= 60 or Enemies() == 2) and not ColossusSmash:ready(1.5)) or ColossusSmash:up() or Target.timeToDie < 5) then
			return ExecuteArms
		end
		if UseCooldown() and DragonRoar.known and DragonRoar:ready() and not (ColossusSmash:ready(1.5) or ColossusSmash:up()) then
			ability.cd = DragonRoar
		end
		if UseCooldown() and Bladestorm.known and Bladestorm:ready() and not (ColossusSmash:ready(6) or (Ravager.known and Ravager:ready(6))) then
			ability.cd = Bladestorm
		end
		if (Enemies() > 4 or Target.healthPercentage > 20) and not ColossusSmash:ready(1.5) then
			if Rage() >= 10 and GlyphOfResonatingPower.known and ThunderClap:ready() then
				return ThunderClap
			elseif Rage() >= 20 then
				return Whirlwind
			end
		elseif Rage() >= 5 and Target.timeToDie > 8 and not Rend:up() then -- cycle targets needed
			return Rend
		end
		if Siegebreaker.known and Siegebreaker:ready() then
			return Siegebreaker
		elseif StormBolt.known and StormBolt:ready() and (ColossusSmash:up() or not ColossusSmash:ready(4)) then
			return StormBolt
		elseif Enemies() >= 3 and Shockwave.known and Shockwave:ready() then
			return Shockwave
		end
		if Enemies() < 3 and UseCooldown() and Shockwave.known and Shockwave:ready() then
			ability.cd = Shockwave
		end
		if Rage() >= 10 and ImpendingVictory.known and ImpendingVictory:ready() then
			return ImpendingVictory
		end
	end
end

local function DetermineAbilityFury()
	if UseCooldown() then
		if Smash.pot and DraenicStrength:ready() and ((Target.healthPercentage < 20 and Recklessness:up()) or Target.timeToDie < 25) then
			ability.cd = DraenicStrength
		elseif Recklessness:ready() and (((Target.timeToDie > 190 or Target.healthPercentage < 20) and (Bloodbath:up() or (Smash.reckless_bloodbath and Bloodbath:ready()) or not Bloodbath.known)) or Target.timeToDie < 10 or AngerManagement.known) then
			ability.cd = Recklessness
		elseif Avatar.known and Avatar:ready() and (Recklessness:up() or Target.timeToDie < 30) then
			ability.cd = Avatar
		elseif BerserkerRage:ready() and (Enrage:down() or (UnquenchableThirst.known and RagingBlowBuff:down())) then
			ability.cd = BerserkerRage
		elseif Bloodbath.known and Bloodbath:ready() then
			ability.cd = Bloodbath
		end
	end
	if Smash.stance and not InBattleStance() then
		return BattleStance
	elseif Smash.shout then
		if not APBuffActive() then
			return BattleShout
		elseif not (InCombat() or StaminaBuffActive() or BattleShout:up()) then
			return CommandingShout
		end
	end
	if Enemies() == 1 then
		if Rage() > 110 and Target.healthPercentage > 20 then
			return WildStrike
		elseif Bloodthirst:ready() and (Enrage:down() or (not UnquenchableThirst.known and Rage() < 80)) then
			return Bloodthirst
		end
		if UseCooldown() and Ravager.known and Ravager:ready() and (Bloodbath:up() or not Bloodbath.known) then
			ability.cd = Ravager
		end
		if SuddenDeath:up() then
			return Execute
		elseif Siegebreaker.known and Siegebreaker:ready() then
			return Siegebreaker
		elseif StormBolt.known and StormBolt:ready() then
			return StormBolt
		elseif Rage() >= 30 and Target.healthPercentage < 20 and (Enrage:up() or Target.timeToDie < 12) then
			return Execute
		elseif Bloodsurge:up() then
			return WildStrike
		end
		if UseCooldown() and DragonRoar.known and DragonRoar:ready() and (Bloodbath:up() or not Bloodbath.known) then
			ability.cd = DragonRoar
		end
		if Rage() >= 10 and RagingBlowBuff:up() then
			return RagingBlow
		elseif Rage() >= 45 and Enrage:up() and Target.healthPercentage > 20 then
			return WildStrike
		end
		if UseCooldown() and Shockwave.known and Shockwave:ready() and not UnquenchableThirst.known then
			ability.cd = Shockwave
		end
		if Rage() >= 10 and ImpendingVictory.known and ImpendingVictory:ready() and Target.healthPercentage > 20 and not UnquenchableThirst.known then
			return ImpendingVictory
		elseif Bloodthirst:ready() then
			return Bloodthirst
		end
	elseif Enemies() == 2 then
		if UseCooldown() then
			if Ravager.known and Ravager:ready() and (Bloodbath:up() or not Bloodbath.known) then
				ability.cd = Ravager
			elseif DragonRoar.known and DragonRoar:ready() and (Bloodbath:up() or not Bloodbath.known) then
				ability.cd = DragonRoar
			elseif Bladestorm.known and Bladestorm:ready() and Enrage:remains() > 6 then
				ability.cd = Bladestorm
			end
		end
		if Bloodthirst:ready() and (Enrage:down() or Rage() < 50 or RagingBlowBuff:down()) then
			return Bloodthirst
		elseif SuddenDeath:up() or (Rage() >= 30 and Target.healthPercentage < 20) then
			return Execute
		elseif RagingBlowBuff:up() and Rage() >= 10 and MeatCleaver:up() then
			return RagingBlow
		elseif MeatCleaver:down() and Rage() >= 30 then
			return Whirlwind
		elseif Bloodsurge:up() and Rage() > 75 then
			return WildStrike
		elseif Bloodthirst:ready() then
			return Bloodthirst
		elseif Rage() > RageMax() - 20 then
			return Whirlwind
		elseif Bloodsurge:up() then
			return WildStrike
		end
	elseif Enemies() == 3 then
		if UseCooldown() then
			if Ravager.known and Ravager:ready() and (Bloodbath:up() or not Bloodbath.known) then
				ability.cd = Ravager
			elseif Bladestorm.known and Bladestorm:ready() and Enrage:remains() > 6 then
				ability.cd = Bladestorm
			end
		end
		if Bloodthirst:ready() and (Enrage:down() or Rage() < 50 or RagingBlowBuff:down()) then
			return Bloodthirst
		elseif SuddenDeath:up() then
			return Execute
		elseif RagingBlowBuff:up() and Rage() >= 10 and MeatCleaver:stack() >= 2 then
			return RagingBlow
		end
		if UseCooldown() and DragonRoar.known and DragonRoar:ready() and (Bloodbath:up() or not Bloodbath.known) then
			ability.cd = DragonRoar
		end
		if Rage() >= 30 then
			return Whirlwind
		elseif Bloodthirst:ready() then
			return Bloodthirst
		elseif Bloodsurge:up() then
			return WildStrike
		end
	elseif Enemies() >= 4 then
		if UseCooldown() and Ravager.known and Ravager:ready() and (Bloodbath:up() or not Bloodbath.known) then
			ability.cd = Ravager
		end
		if RagingBlowBuff:up() and Rage() >= 10 and Enrage:up() and MeatCleaver:stack() >= 3 then
			return RagingBlow
		elseif Bloodthirst:ready() and (Enrage:down() or Rage() < 50 or RagingBlowBuff:down()) then
			return Bloodthirst
		elseif RagingBlowBuff:up() and Rage() >= 10 and MeatCleaver:stack() >= 3 then
			return RagingBlow
		end
		if UseCooldown() and Bladestorm.known and Bladestorm:ready() and Enrage:remains() > 6 then
			ability.cd = Recklessness:ready() and Recklessness or Bladestorm
		end
		if Rage() >= 30 then
			return Whirlwind
		elseif SuddenDeath:up() then
			return Execute
		end
		if UseCooldown() and DragonRoar.known and DragonRoar:ready() and (Bloodbath:up() or not Bloodbath.known) then
			ability.cd = DragonRoar
		end
		if Bloodthirst:ready() then
			return Bloodthirst
		elseif Bloodsurge:up() then
			return WildStrike
		end
	end
end

local function DetermineAbilityGladiator()
	if UseCooldown() then
		if Avatar.known and Avatar:ready() then
			ability.cd = Avatar
		elseif Bloodbath.known and Bloodbath:ready() then
			ability.cd = Bloodbath
		elseif Smash.pot and DraenicStrength:ready() and (ShieldCharge:up() or Avatar:up() or Bloodbath:up()) then
			ability.cd = DraenicStrength
		end
	end
	if not ability.cd then
		if ShieldCharge:ready() and Rage() >= 20 and ((ShieldSlam:ready(0.3) and ShieldCharge:down()) or ShieldCharge:charges() == 2) then
			ability.cd = ShieldCharge
		elseif BerserkerRage:ready() and Enrage:down() then
			ability.cd = BerserkerRage
		elseif HeroicStrike:ready() and HeroicStrike:usable() and (Rage() >= RageMax() - 20 or Ultimatum:up() or UnyieldingStrikes:stack() > 4 or Target.timeToDie < 10 or (Target.healthPercentage > 20 and (ShieldCharge:up() or (UnyieldingStrikes:up() and Rage() >= UnyieldingStrikes:stack() * 5)))) then
			ability.cd = HeroicStrike
		end
	end
	if UnyieldingStrikes.known and UnyieldingStrikes:stack() > 0 and UnyieldingStrikes:stack() < 6 and UnyieldingStrikes:remains() < 1.5 then
		return Devastate
	end
	if Smash.shout then
		if not APBuffActive() then
			return BattleShout
		elseif not (InCombat() or StaminaBuffActive() or BattleShout:up()) then
			return CommandingShout
		end
	end
	if Enemies() == 1 then
		if ShieldSlam:ready() then
			return ShieldSlam
		elseif Revenge:ready() then
			return Revenge
		elseif SuddenDeath:up() then
			return Execute
		elseif StormBolt.known and StormBolt:ready() then
			return StormBolt
		elseif DragonRoar.known and DragonRoar:ready() then
			return DragonRoar
		elseif Rage() >= 60 and Target.healthPercentage < 20 then
			return Execute
		else
			return Devastate
		end
	else
		if Revenge:ready() then
			return Revenge
		elseif ShieldSlam:ready() then
			return ShieldSlam
		elseif DragonRoar.known and DragonRoar:ready() and (not Bloodbath.known or Bloodbath:up() or not Bloodbath:ready(10)) then
			return DragonRoar
		elseif Shockwave.known and Shockwave:ready() then
			return Shockwave
		elseif StormBolt.known and StormBolt:ready() and (not Bloodbath.known or Bloodbath:up() or not Bloodbath:ready(7)) then
			return StormBolt
		elseif Enemies() > 4 and Rage() >= 10 and ThunderClap:ready() and DeepWounds:remains() < 3 then
			return ThunderClap
		end
		if UseCooldown() and Bladestorm.known and Bladestorm:ready() and ShieldCharge:down() then
			ability.cd = Bladestorm
		end
		if SuddenDeath:up() then
			return Execute
		elseif Enemies() > 6 and ThunderClap:ready() and Rage() >= 10 then
			return ThunderClap
		elseif (UnyieldingStrikes.known and UnyieldingStrikes:stack() < 5) or not ShieldSlam:ready(0.4) then
			return Devastate
		end
	end
end

local function DetermineAbilityProtection()
	if UseCooldown() then
		if Avatar.known and Avatar:ready() then
			ability.cd = Avatar
		elseif Bloodbath.known and Bloodbath:ready() then
			ability.cd = Bloodbath
		elseif Smash.pot and DraenicStrength:ready() and (Avatar:up() or Bloodbath:up()) then
			ability.cd = DraenicStrength
		elseif BerserkerRage:ready() and Enrage:down() then
			ability.cd = BerserkerRage
		end
	end
	if not ability.cd and HeroicStrike:ready() and HeroicStrike:usable() and (Rage() >= RageMax() - 20 or Ultimatum:up() or UnyieldingStrikes:stack() > 4 or Target.timeToDie < 10) then
		ability.cd = HeroicStrike
	end
	if UnyieldingStrikes.known and UnyieldingStrikes:stack() > 0 and UnyieldingStrikes:stack() < 6 and UnyieldingStrikes:remains() < 1.5 then
		return Devastate
	end
	if Smash.shout then
		if not APBuffActive() then
			return BattleShout
		elseif not (InCombat() or StaminaBuffActive() or BattleShout:up()) then
			return CommandingShout
		end
	end
	if Enemies() == 1 then
		if ShieldSlam:ready() then
			return ShieldSlam
		elseif Revenge:ready() then
			return Revenge
		elseif SuddenDeath:up() then
			return Execute
		elseif StormBolt.known and StormBolt:ready() then
			return StormBolt
		elseif DragonRoar.known and DragonRoar:ready() then
			return DragonRoar
		elseif Rage() >= 60 and Target.healthPercentage < 20 then
			return Execute
		elseif ImpendingVictory.known and ImpendingVictory:ready() and Rage() >= 10 and not ShieldSlam:ready(1) then
			return ImpendingVictory
		else
			return Devastate
		end
	else
		if Revenge:ready() then
			return Revenge
		elseif ShieldSlam:ready() then
			return ShieldSlam
		elseif DragonRoar.known and DragonRoar:ready() and (not Bloodbath.known or Bloodbath:up() or not Bloodbath:ready(10)) then
			return DragonRoar
		elseif Shockwave.known and Shockwave:ready() then
			return Shockwave
		elseif StormBolt.known and StormBolt:ready() and (not Bloodbath.known or Bloodbath:up() or not Bloodbath:ready(7)) then
			return StormBolt
		elseif Enemies() > 4 and Rage() >= 10 and ThunderClap:ready() and DeepWounds:remains() < 3 then
			return ThunderClap
		end
		if UseCooldown() and Bladestorm.known and Bladestorm:ready() then
			ability.cd = Bladestorm
		end
		if SuddenDeath:up() then
			return Execute
		elseif Enemies() > 6 and ThunderClap:ready() and Rage() >= 10 then
			return ThunderClap
		elseif (UnyieldingStrikes.known and UnyieldingStrikes:stack() < 5) or not ShieldSlam:ready(0.4) then
			return Devastate
		end
	end
end

local function DetermineAbility()
	ability.cd = nil
	if currentSpec == 1 then
		return DetermineAbilityArms()
	elseif currentSpec == 2 then
		return DetermineAbilityFury()
	elseif currentSpec == 3 then
		if GladiatorStance:up() then
			return DetermineAbilityGladiator()
		end
		return DetermineAbilityProtection()
	end
	smashPreviousPanel:Hide()
end

local function DetermineInterrupt()
	if Pummel:ready() then
		return Pummel
	end
end

local function UpdateInterrupt()
	local _, _, _, _, start, ends, _, _, notInterruptible = UnitCastingInfo('target')
	if not start or notInterruptible then
		smashInterruptPanel:Hide()
	else
		smashInterruptPanel:Show()
		smashInterruptPanel.cast:SetCooldown(start / 1000, (ends - start) / 1000)
		abilityInterrupt = DetermineInterrupt()
		if abilityInterrupt then
			smashInterruptPanel.icon:SetTexture(abilityInterrupt.icon)
			smashInterruptPanel.icon:Show()
			smashInterruptPanel.border:Show()
		else
			smashInterruptPanel.icon:Hide()
			smashInterruptPanel.border:Hide()
		end
	end
end

local function UpdateEnrage()
	local _, id, duration, expires
	for i = 1, 40 do
		_, _, _, _, _, duration, expires, _, _, _, id = UnitBuff('player', i)
		if id == Enrage.spellId then
			break
		end
	end
	if duration then
		smashEnragePanel.duration:SetCooldown(expires - duration, duration)
		smashEnragePanel:Show()
	else
		smashEnragePanel:Hide()
	end
end

local function DenyOverlayGlow(actionButton)
	if not Smash.glow_blizzard then
		actionButton.overlay:Hide()
	end
end

hooksecurefunc('ActionButton_ShowOverlayGlow', DenyOverlayGlow) -- Disable Blizzard's built-in action button glowing

local function CreateOverlayGlows()
	local GenerateGlow = function(button)
		if button then
			local w, h, glow
			w, h = button:GetSize()
			glow = CreateFrame('Frame', nil, button, 'ActionBarButtonSpellActivationAlert')
			glow:Hide()
			glow:SetSize(w * 1.4, h * 1.4)
			glow:SetPoint('TOPLEFT', button, 'TOPLEFT', -w * 0.2, h * 0.2)
			glow:SetPoint('BOTTOMRIGHT', button, 'BOTTOMRIGHT', w * 0.2, -h * 0.2)
			glow.button = button
			glows[#glows + 1] = glow
		end
	end
	if Bartender4 then
		for i = 1, 120 do
			GenerateGlow(_G['BT4Button' .. i])
		end
	elseif ElvUI then
		for b = 1, 6 do
			for i = 1, 12 do
				GenerateGlow(_G['ElvUI_Bar' .. b .. 'Button' .. i])
			end
		end
	else
		for i = 1, 12 do
			GenerateGlow(_G['ActionButton' .. i])
			GenerateGlow(_G['MultiBarLeftButton' .. i])
			GenerateGlow(_G['MultiBarRightButton' .. i])
			GenerateGlow(_G['MultiBarBottomLeftButton' .. i])
			GenerateGlow(_G['MultiBarBottomRightButton' .. i])
		end
		if Dominos then
			for i = 1, 60 do
				GenerateGlow(_G['DominosActionButton' .. i])
			end
		end
	end
end

local function UpdateGlows()
	local glow, icon
	for i = 1, #glows do
		glow = glows[i]
		icon = glow.button.icon:GetTexture()
		if icon and glow.button.icon:IsVisible() and (
			(Smash.glow_main and ability.main and icon == ability.main.icon) or
			(Smash.glow_cooldown and ability.cd and icon == ability.cd.icon) or
			(Smash.glow_interrupt and ability.interrupt and icon == ability.interrupt.icon)
			) then
			if not glow:IsVisible() then
				glow.animIn:Play()
			end
		elseif glow:IsVisible() then
			glow.animIn:Stop()
			glow:Hide()
		end
	end
end

function events:ACTIONBAR_SLOT_CHANGED()
	UpdateGlows()
end

function events:PLAYER_LOGIN()
	me = UnitGUID('player')
	CreateOverlayGlows()
end

local function Disappear()
	ability.main = nil
	ability.cd = nil
	ability.interrupt = nil
	UpdateGlows()
	smashPanel:Hide()
	smashPanel.border:Hide()
	smashPreviousPanel:Hide()
	smashCooldownPanel:Hide()
	smashInterruptPanel:Hide()
	smashEnragePanel:Hide()
end

function Smash_ToggleTargetMode()
	local mode = targetMode + 1
	Smash_SetTargetMode(mode > #targetModes[currentSpec] and 1 or mode)
end

function Smash_ToggleTargetModeReverse()
	local mode = targetMode - 1
	Smash_SetTargetMode(mode < 1 and #targetModes[currentSpec] or mode)
end

function Smash_SetTargetMode(mode)
	targetMode = min(mode, #targetModes[currentSpec])
	smashPanel.targets:SetText(targetModes[currentSpec][targetMode][2])
end

function events:PLAYER_TARGET_CHANGED()
	if ElvUI and #glows == 0 then
		CreateOverlayGlows()
	end
	if Smash.hide_spec ~= GetActiveSpecGroup() then
		local previouslyHostile = Target.hostile
		Target.hostile = UnitCanAttack('player', 'target')
		if Target.hostile then
			Target.guid = UnitGUID('target')
			Target.level = UnitLevel('target')
			Target.boss = Target.level == -1 or (Target.level >= UnitLevel('player') + 2 and not UnitInRaid('player'))
			for i = 1, #Target.healthArray do
				Target.healthArray[i] = UnitHealth('target')
			end
			abilityTimer = Smash.frequency
			smashPanel:Show()
		elseif Smash.always_on then
			Target.guid = 0
			Target.boss = false
			Target.hostile = true
			for i = 1, #Target.healthArray do
				Target.healthArray[i] = 0
			end
			abilityTimer = Smash.frequency
			smashPanel:Show()
		elseif previouslyHostile then
			Disappear()
		end
	end
end

function events:UNIT_FACTION(unitID)
	if unitID == 'target' then
		events:PLAYER_TARGET_CHANGED()
	end
end

--[=[
local function Equipped(slot, item)
	return (GetInventoryItemLink('player', slot) or ''):match('%[([^%]]*)%]') == item and 1 or 0
end

function events:PLAYER_EQUIPMENT_CHANGED()
	-- use for tier bonus checking
end
]=]

function events:PLAYER_SPECIALIZATION_CHANGED(unitName)
	if unitName == 'player' then
		for i = 1, #abilities do
			abilities[i].name, _, abilities[i].icon = GetSpellInfo(abilities[i].spellId)
			abilities[i].known = IsPlayerSpell(abilities[i].spellId)
		end
		currentSpec = GetSpecialization() or 0
		if Smash.hide_spec == GetActiveSpecGroup() then
			Disappear()
		end
		Smash_SetTargetMode(1)
		events:PLAYER_TARGET_CHANGED()
	end
end

function events:PLAYER_ENTERING_WORLD()
	--events:PLAYER_EQUIPMENT_CHANGED()
	events:PLAYER_SPECIALIZATION_CHANGED('player')
end

local function UpdateDraggable()
	smashPanel:EnableMouse(Smash.aoe or not Smash.locked)
	if Smash.aoe then
		smashPanel.button:Show()
	else
		smashPanel.button:Hide()
	end
	if Smash.locked then
		smashPanel:SetScript('OnDragStart', nil)
		smashPanel:SetScript('OnDragStop', nil)
		smashPanel:RegisterForDrag(nil)
		smashPreviousPanel:EnableMouse(false)
		smashCooldownPanel:EnableMouse(false)
		smashInterruptPanel:EnableMouse(false)
		smashEnragePanel:EnableMouse(false)
	else
		if not Smash.aoe then
			smashPanel:SetScript('OnDragStart', smashPanel.StartMoving)
			smashPanel:SetScript('OnDragStop', smashPanel.StopMovingOrSizing)
			smashPanel:RegisterForDrag('LeftButton')
		end
		smashPreviousPanel:EnableMouse(true)
		smashCooldownPanel:EnableMouse(true)
		smashInterruptPanel:EnableMouse(true)
		smashEnragePanel:EnableMouse(true)
	end
end

local function UpdateAlpha()
	smashPanel:SetAlpha(Smash.alpha)
	smashPreviousPanel:SetAlpha(Smash.alpha)
	smashCooldownPanel:SetAlpha(Smash.alpha)
	smashInterruptPanel:SetAlpha(Smash.alpha)
	smashEnragePanel:SetAlpha(Smash.alpha)
end

local function UpdateHealthArray()
	Target.healthArray = {}
	for i = 1, floor(3 / Smash.frequency) do
		Target.healthArray[i] = 0
	end
end

function events:ADDON_LOADED(name)
	if name == 'Smash' then
		if not Smash.frequency then
			print('It looks like this is your first time getting Smashed, why don\'t you take some time to familiarize yourself with the commands?')
			print('Type |cFFFFD000/smash|r for a list of commands.')
		end
		if UnitLevel('player') < 90 then
			print('[|cFFFFD000Warning|r] Smash is not designed for players under level 90, and almost certainly will not operate properly!')
		end
		InitializeVariables()
		UpdateHealthArray()
		UpdateDraggable()
		UpdateAlpha()
		smashPanel:SetScale(Smash.scale_main)
		smashPreviousPanel:SetScale(Smash.scale_previous)
		smashCooldownPanel:SetScale(Smash.scale_cooldown)
		smashInterruptPanel:SetScale(Smash.scale_interrupt)
		smashEnragePanel:SetScale(Smash.scale_enrage)
		smashEnragePanel.icon:SetTexture(Enrage.icon)
	end
end

function events:COMBAT_LOG_EVENT_UNFILTERED(self, eventType, hideCaster, srcGUID, srcName, srcFlags, srcRaidFlags, dstGUID, dstName, dstFlags, dstRaidFlags, spellId)
	if srcGUID == me and Smash.previous and smashPanel:IsVisible() then
		if eventType == 'SPELL_MISSED' and Smash.miss_effect and ability.previous and spellId == ability.previous.spellId then
			smashPreviousPanel.border:SetTexture('Interface\\AddOns\\Smash\\misseffect.blp')
		elseif eventType == 'SPELL_CAST_SUCCESS' and ability.main and spellId == ability.main.spellId then
			ability.previous = ability.main
			smashPreviousPanel.border:SetTexture('Interface\\AddOns\\Smash\\border.blp')
			smashPreviousPanel.icon:SetTexture(ability.previous.icon)
			smashPreviousPanel:Show()
		end
	end
end

smashPanel.button:SetScript('OnClick', function(self, button, down)
	if down then
		if button == 'LeftButton' then
			Smash_ToggleTargetMode()
		elseif button == 'RightButton' then
			Smash_ToggleTargetModeReverse()
		elseif button == 'MiddleButton' then
			Smash_SetTargetMode(1)
		end
	end
end)

smashPanel:SetScript('OnUpdate', function(self, elapsed)
	abilityTimer = abilityTimer + elapsed
	if abilityTimer >= Smash.frequency then
		UpdateVars()
		ability.main = DetermineAbility()
		if ability.main ~= ability.last_main then
			if ability.main then
				smashPanel.icon:SetTexture(ability.main.icon)
				smashPanel.icon:Show()
				smashPanel.border:Show()
			else
				smashPanel.icon:Hide()
				smashPanel.border:Hide()
			end
		end
		if ability.cd ~= ability.last_cd then
			if ability.cd then
				smashCooldownPanel.icon:SetTexture(ability.cd.icon)
				smashCooldownPanel:Show()
			else
				smashCooldownPanel:Hide()
			end
		end
		if Smash.gcd then
			local gcdStart, gcdDuration = GetSpellCooldown(5308)
			if gcdStart == 0 then
				smashPanel.gcd:Hide()
			else
				smashPanel.gcd:SetCooldown(gcdStart, gcdDuration)
				smashPanel.gcd:Show()
			end
		end
		if ability.cd == HeroicStrike then
			gcdStart, gcdDuration = GetSpellCooldown(78)
			if gcdStart == 0 then
				smashCooldownPanel.cd:Hide()
			else
				smashCooldownPanel.cd:SetCooldown(gcdStart, gcdDuration)
				smashCooldownPanel.cd:Show()
			end
		else
			smashCooldownPanel.cd:Hide()
		end
		if Smash.dimmer then
			if not ability.main or ability.main:usable() then
				smashPanel.dimmer:Hide()
			else
				smashPanel.dimmer:Show()
			end
		end
		if Smash.interrupt then
			UpdateInterrupt()
		end
		if Smash.enrage then
			UpdateEnrage()
		end
		UpdateGlows()
		abilityTimer = 0
	end
end)

smashPanel:SetScript('OnEvent', function(self, event, ...) events[event](self, ...) end)
for event in pairs(events) do
	smashPanel:RegisterEvent(event)
end

function SlashCmdList.Smash(msg, editbox)
	msg = { strsplit(' ', strlower(msg)) }
	if msg[1] == 'locked' then
		if msg[2] then
			Smash.locked = msg[2] == 'on'
			UpdateDraggable()
		end
		print('Smash - Locked: ' .. (Smash.locked and '|cFF00C000On' or '|cFFC00000Off'))
	elseif msg[1] == 'scale' then
		if msg[2] == 'prev' then
			if msg[3] then
				Smash.scale_previous = tonumber(msg[3]) or 0.7
				smashPreviousPanel:SetScale(Smash.scale_previous)
			end
			print('Smash - Previous ability icon scale set to: |cFFFFD000' .. Smash.scale_previous .. '|r times')
		elseif msg[2] == 'main' then
			if msg[3] then
				Smash.scale_main = tonumber(msg[3]) or 1
				smashPanel:SetScale(Smash.scale_main)
			end
			print('Smash - Main ability icon scale set to: |cFFFFD000' .. Smash.scale_main .. '|r times')
		elseif msg[2] == 'cd' then
			if msg[3] then
				Smash.scale_cooldown = tonumber(msg[3]) or 0.7
				smashCooldownPanel:SetScale(Smash.scale_cooldown)
			end
			print('Smash - Cooldown ability icon scale set to: |cFFFFD000' .. Smash.scale_cooldown .. '|r times')
		elseif msg[2] == 'interrupt' then
			if msg[3] then
				Smash.scale_interrupt = tonumber(msg[3]) or 0.4
				smashInterruptPanel:SetScale(Smash.scale_interrupt)
			end
			print('Smash - Interrupt ability icon scale set to: |cFFFFD000' .. Smash.scale_interrupt .. '|r times')
		elseif msg[2] == 'enrage' then
			if msg[3] then
				Smash.scale_enrage = tonumber(msg[3]) or 0.4
				smashEnragePanel:SetScale(Smash.scale_enrage)
			end
			print('Smash - Enrage icon scale set to: |cFFFFD000' .. Smash.scale_enrage .. '|r times')
		else
			print('Smash - Default icon scale options are |cFFFFD000prev 0.7|r, |cFFFFD000main 1|r, |cFFFFD000cd 0.7|r, |cFFFFD000interrupt 0.4|r, and |cFFFFD000enrage 0.4')
		end
	elseif msg[1] == 'alpha' then
		if msg[2] then
			Smash.alpha = max(min((tonumber(msg[2]) or 100), 100), 0) / 100
			UpdateAlpha()
		end
		print('Smash - Icon transparency set to: |cFFFFD000' .. Smash.alpha * 100 .. '%|r')
	elseif msg[1] == 'frequency' then
		if msg[2] then
			Smash.frequency = tonumber(msg[2]) or 0.05
			UpdateHealthArray()
		end
		print('Smash - Calculation frequency: Every |cFFFFD000' .. Smash.frequency .. '|r seconds')
	elseif msg[1] == 'glow' then
		if msg[2] == 'main' then
			if msg[3] then
				Smash.glow_main = msg[3] == 'on'
			end
			print('Smash - Glowing ability buttons (main icon): ' .. (Smash.glow_main and '|cFF00C000On' or '|cFFC00000Off'))
		elseif msg[2] == 'cd' then
			if msg[3] then
				Smash.glow_cooldown = msg[3] == 'on'
			end
			print('Smash - Glowing ability buttons (cooldown icon): ' .. (Smash.glow_cooldown and '|cFF00C000On' or '|cFFC00000Off'))
		elseif msg[2] == 'interrupt' then
			if msg[3] then
				Smash.glow_interrupt = msg[3] == 'on'
			end
			print('Smash - Glowing ability buttons (interrupt icon): ' .. (Smash.glow_interrupt and '|cFF00C000On' or '|cFFC00000Off'))
		elseif msg[2] == 'blizzard' then
			if msg[3] then
				Smash.glow_blizzard = msg[3] == 'on'
			end
			print('Smash - Blizzard default proc glow: ' .. (Smash.glow_blizzard and '|cFF00C000On' or '|cFFC00000Off'))
		else
			print('Smash - Possible glow options are: |cFFFFD000main|r, |cFFFFD000cd|r, |cFFFFD000interrupt|r, and |cFFFFD000blizzard')
		end
		UpdateGlows()
	elseif msg[1] == 'previous' then
		if msg[2] then
			Smash.previous = msg[2] == 'on'
			events:PLAYER_TARGET_CHANGED()
		end
		print('Smash - Previous ability icon: ' .. (Smash.previous and '|cFF00C000On' or '|cFFC00000Off'))
	elseif msg[1] == 'always' then
		if msg[2] then
			Smash.always_on = msg[2] == 'on'
			events:PLAYER_TARGET_CHANGED()
		end
		print('Smash - Show the Smash UI without a target: ' .. (Smash.always_on and '|cFF00C000On' or '|cFFC00000Off'))
	elseif msg[1] == 'cd' then
		if msg[2] then
			Smash.cooldown = msg[2] == 'on'
		end
		print('Smash - Use Smash for cooldown management: ' .. (Smash.cooldown and '|cFF00C000On' or '|cFFC00000Off'))
	elseif msg[1] == 'gcd' then
		if msg[2] then
			Smash.gcd = msg[2] == 'on'
			if not Smash.gcd then
				smashPanel.gcd:Hide()
			end
		end
		print('Smash - Global cooldown swipe: ' .. (Smash.gcd and '|cFF00C000On' or '|cFFC00000Off'))
	elseif msg[1] == 'dim' then
		if msg[2] then
			Smash.dimmer = msg[2] == 'on'
			if not Smash.dimmer then
				smashPanel.dimmer:Hide()
			end
		end
		print('Smash - Dim main ability icon when you don\'t have enough rage to use it: ' .. (Smash.dimmer and '|cFF00C000On' or '|cFFC00000Off'))
	elseif msg[1] == 'miss' then
		if msg[2] then
			Smash.miss_effect = msg[2] == 'on'
		end
		print('Smash - Red border around previous ability when it fails to hit: ' .. (Smash.miss_effect and '|cFF00C000On' or '|cFFC00000Off'))
	elseif msg[1] == 'aoe' then
		if msg[2] then
			Smash.aoe = msg[2] == 'on'
			Smash_SetTargetMode(1)
			UpdateDraggable()
		end
		print('Smash - Allow clicking main ability icon to toggle amount of targets (disables moving): ' .. (Smash.aoe and '|cFF00C000On' or '|cFFC00000Off'))
	elseif msg[1] == 'bossonly' then
		if msg[2] then
			Smash.boss_only = msg[2] == 'on'
		end
		print('Smash - Only use cooldowns on bosses: ' .. (Smash.boss_only and '|cFF00C000On' or '|cFFC00000Off'))
	elseif msg[1] == 'hidespec' then
		if msg[2] then
			local spec = tonumber(msg[2]) or 0
			if spec >= 0 and spec <= 2 then
				Smash.hide_spec = spec
				events:PLAYER_SPECIALIZATION_CHANGED('player')
			end
		end
		print('Smash - Hide in specialization: |cFFFFD000' .. (Smash.hide_spec == 0 and 'None' or Smash.hide_spec))
	elseif msg[1] == 'interrupt' then
		if msg[2] then
			Smash.interrupt = msg[2] == 'on'
		end
		print('Smash - Show an icon for interruptable spells: ' .. (Smash.interrupt and '|cFF00C000On' or '|cFFC00000Off'))
	elseif msg[1] == 'enrage' then
		if msg[2] then
			Smash.enrage = msg[2] == 'on'
		end
		print('Smash - Show an icon for Enrage uptime: ' .. (Smash.enrage and '|cFF00C000On' or '|cFFC00000Off'))
	elseif msg[1] == 'pot' then
		if msg[2] then
			Smash.pot = msg[2] == 'on'
		end
		print('Smash - Show Draenic Strength potions in cooldown UI: ' .. (Smash.pot and '|cFF00C000On' or '|cFFC00000Off'))
	elseif msg[1] == 'stance' then
		if msg[2] then
			Smash.stance = msg[2] == 'on'
		end
		print('Smash - Warn if not in the right combat stance for specialization: ' .. (Smash.stance and '|cFF00C000On' or '|cFFC00000Off'))
	elseif msg[1] == 'shout' then
		if msg[2] then
			Smash.shout = msg[2] == 'on'
		end
		print('Smash - Warn if missing Battle Shout or Commanding Shout buff: ' .. (Smash.shout and '|cFF00C000On' or '|cFFC00000Off'))
	elseif msg[1] == 'rbb' then
		if msg[2] then
			Smash.reckless_bloodbath = msg[2] == 'on'
		end
		print('Smash - Bloodbath macroed into Recklessness: ' .. (Smash.reckless_bloodbath and '|cFF00C000On' or '|cFFC00000Off'))
	elseif msg[1] == 'reset' then
		smashPanel:ClearAllPoints()
		smashPanel:SetPoint('CENTER', 0, -169)
		smashPreviousPanel:ClearAllPoints()
		smashPreviousPanel:SetPoint('BOTTOMRIGHT', smashPanel, 'BOTTOMLEFT', -10, -5)
		smashCooldownPanel:ClearAllPoints()
		smashCooldownPanel:SetPoint('BOTTOMLEFT', smashPanel, 'BOTTOMRIGHT', 10, -5)
		smashInterruptPanel:ClearAllPoints()
		smashInterruptPanel:SetPoint('TOPLEFT', smashPanel, 'TOPRIGHT', 16, 25)
		smashEnragePanel:ClearAllPoints()
		smashEnragePanel:SetPoint('TOPRIGHT', smashPanel, 'TOPLEFT', -16, 25)
		print('Smash - Position has been reset to default')
	else
		print('Smash (version: |cFFFFD000' .. GetAddOnMetadata('Smash', 'Version') .. '|r) - Commands:')
		print('  /smash locked |cFF00C000on|r/|cFFC00000off|r - lock the Smash UI so that it can\'t be moved')
		print('  /smash scale |cFFFFD000prev|r/|cFFFFD000main|r/|cFFFFD000cd|r/|cFFFFD000interrupt|r/|cFFFFD000enrage|r |cFFFFD000[number]|r - adjust the scale of the Smash UI icons')
		print('  /smash alpha |cFFFFD000[percent]|r - adjust the transparency of the Smash UI icons')
		print('  /smash frequency |cFFFFD000[number]|r - set the calculation frequency (default is every 0.05 seconds)')
		print('  /smash glow |cFFFFD000main|r/|cFFFFD000cd|r/|cFFFFD000interrupt|r/|cFFFFD000blizzard|r |cFF00C000on|r/|cFFC00000off|r - glowing ability buttons on action bars')
		print('  /smash previous |cFF00C000on|r/|cFFC00000off|r - previous ability icon')
		print('  /smash always |cFF00C000on|r/|cFFC00000off|r - show the Smash UI without a target')
		print('  /smash cd |cFF00C000on|r/|cFFC00000off|r - use Smash for cooldown management')
		print('  /smash gcd |cFF00C000on|r/|cFFC00000off|r - show global cooldown swipe on main ability icon')
		print('  /smash dim |cFF00C000on|r/|cFFC00000off|r - dim main ability icon when you don\'t have enough rage to use it')
		print('  /smash miss |cFF00C000on|r/|cFFC00000off|r - red border around previous ability when it fails to hit')
		print('  /smash aoe |cFF00C000on|r/|cFFC00000off|r - allow clicking main ability icon to toggle amount of targets (disables moving)')
		print('  /smash bossonly |cFF00C000on|r/|cFFC00000off|r - only use cooldowns on bosses')
		print('  /smash hidespec |cFFFFD0000|r/|cFFFFD0001|r/|cFFFFD0002|r - hide Smash in specialization 1 or 2 (0 is neither)')
		print('  /smash interrupt |cFF00C000on|r/|cFFC00000off|r - show an icon for interruptable spells')
		print('  /smash enrage |cFF00C000on|r/|cFFC00000off|r - show an icon for Enrage uptime')
		print('  /smash pot |cFF00C000on|r/|cFFC00000off|r - show Draenic Strength potions in cooldown UI')
		print('  /smash stance |cFF00C000on|r/|cFFC00000off|r - warn if not in the right combat stance for specialization')
		print('  /smash shout |cFF00C000on|r/|cFFC00000off|r - warn if missing Battle Shout or Commanding Shout buff')
		print('  /smash rbb |cFF00C000on|r/|cFFC00000off|r - Bloodbath macroed into Recklessness')
		print('  /smash |cFFFFD000reset|r - reset the location of the Smash UI to default')
		if Basic_Resources then
			print('For Basic Resources commands, please type |cFFFFD000/bres')
		end
	end
end